EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_EVENT_SCROLL_STARTED =
   EFL_EVENT_DESCRIPTION("scroll,started");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_EVENT_SCROLL_CHANGED =
   EFL_EVENT_DESCRIPTION("scroll,changed");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_EVENT_SCROLL_FINISHED =
   EFL_EVENT_DESCRIPTION("scroll,finished");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_EVENT_SCROLL_UP =
   EFL_EVENT_DESCRIPTION("scroll,up");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_EVENT_SCROLL_DOWN =
   EFL_EVENT_DESCRIPTION("scroll,down");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_EVENT_SCROLL_LEFT =
   EFL_EVENT_DESCRIPTION("scroll,left");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_EVENT_SCROLL_RIGHT =
   EFL_EVENT_DESCRIPTION("scroll,right");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_EVENT_EDGE_UP =
   EFL_EVENT_DESCRIPTION("edge,up");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_EVENT_EDGE_DOWN =
   EFL_EVENT_DESCRIPTION("edge,down");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_EVENT_EDGE_LEFT =
   EFL_EVENT_DESCRIPTION("edge,left");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_EVENT_EDGE_RIGHT =
   EFL_EVENT_DESCRIPTION("edge,right");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_EVENT_SCROLL_ANIM_STARTED =
   EFL_EVENT_DESCRIPTION("scroll,anim,started");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_EVENT_SCROLL_ANIM_FINISHED =
   EFL_EVENT_DESCRIPTION("scroll,anim,finished");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_EVENT_SCROLL_DRAG_STARTED =
   EFL_EVENT_DESCRIPTION("scroll,drag,started");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_EVENT_SCROLL_DRAG_FINISHED =
   EFL_EVENT_DESCRIPTION("scroll,drag,finished");
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_scrollable_content_pos_set, EFL_FUNC_CALL(pos), Eina_Position2D pos);
EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_scrollable_content_pos_get, Eina_Position2D, ((Eina_Position2D){0}));
EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_scrollable_content_size_get, Eina_Size2D, ((Eina_Size2D){0}));
EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_scrollable_viewport_geometry_get, Eina_Rect, (EINA_RECT_EMPTY()));
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_scrollable_bounce_enabled_set, EFL_FUNC_CALL(horiz, vert), Eina_Bool horiz, Eina_Bool vert);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_ui_scrollable_bounce_enabled_get, EFL_FUNC_CALL(horiz, vert), Eina_Bool *horiz, Eina_Bool *vert);

static Eina_Error
__eolian_efl_ui_scrollable_scroll_freeze_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_scrollable_scroll_freeze_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_scrollable_scroll_freeze_set, EFL_FUNC_CALL(freeze), Eina_Bool freeze);

static Eina_Value
__eolian_efl_ui_scrollable_scroll_freeze_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_ui_scrollable_scroll_freeze_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_scrollable_scroll_freeze_get, Eina_Bool, 0);

static Eina_Error
__eolian_efl_ui_scrollable_scroll_hold_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_scrollable_scroll_hold_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_scrollable_scroll_hold_set, EFL_FUNC_CALL(hold), Eina_Bool hold);

static Eina_Value
__eolian_efl_ui_scrollable_scroll_hold_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_ui_scrollable_scroll_hold_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_scrollable_scroll_hold_get, Eina_Bool, 0);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_scrollable_looping_set, EFL_FUNC_CALL(loop_h, loop_v), Eina_Bool loop_h, Eina_Bool loop_v);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_ui_scrollable_looping_get, EFL_FUNC_CALL(loop_h, loop_v), Eina_Bool *loop_h, Eina_Bool *loop_v);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_scrollable_movement_block_set, EFL_FUNC_CALL(block), Efl_Ui_Layout_Orientation block);
EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_scrollable_movement_block_get, Efl_Ui_Layout_Orientation, 0 /* Efl.Ui.Layout_Orientation.default */);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_scrollable_gravity_set, EFL_FUNC_CALL(x, y), double x, double y);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_ui_scrollable_gravity_get, EFL_FUNC_CALL(x, y), double *x, double *y);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_scrollable_match_content_set, EFL_FUNC_CALL(w, h), Eina_Bool w, Eina_Bool h);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_scrollable_step_size_set, EFL_FUNC_CALL(step), Eina_Position2D step);
EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_scrollable_step_size_get, Eina_Position2D, ((Eina_Position2D){0}));
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_scrollable_scroll, EFL_FUNC_CALL(rect, animation), Eina_Rect rect, Eina_Bool animation);

static Eina_Bool
_efl_ui_scrollable_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_UI_SCROLLABLE_EXTRA_OPS
#define EFL_UI_SCROLLABLE_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_content_pos_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_content_pos_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_content_size_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_viewport_geometry_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_bounce_enabled_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_bounce_enabled_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_scroll_freeze_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_scroll_freeze_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_scroll_hold_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_scroll_hold_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_looping_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_looping_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_movement_block_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_movement_block_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_gravity_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_gravity_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_match_content_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_step_size_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_step_size_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_scroll, NULL),
      EFL_UI_SCROLLABLE_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"scroll_freeze", __eolian_efl_ui_scrollable_scroll_freeze_set_reflect, __eolian_efl_ui_scrollable_scroll_freeze_get_reflect},
      {"scroll_hold", __eolian_efl_ui_scrollable_scroll_hold_set_reflect, __eolian_efl_ui_scrollable_scroll_hold_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_ui_scrollable_class_desc = {
   EO_VERSION,
   "Efl.Ui.Scrollable",
   EFL_CLASS_TYPE_INTERFACE,
   0,
   _efl_ui_scrollable_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_ui_scrollable_interface_get, &_efl_ui_scrollable_class_desc, NULL, NULL);
